<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package Modules
 */
/**************************************************************************/

/**
 * Серверная сторона AJAX панели управления модуля "Пользователи".
 *
 * <a href="http://wiki.a-cms.ru/modules/users">Руководство</a>.
 */

class UsersModule_Request extends A_Request
{
/**
 * Маршрутизатор действий.
 */

  function Action($action)
  {
    switch($action)
    { case "getadduserform": $this->getAddUserForm(); break;
	  case "getedituserform": $this->getEditUserForm(); break;
	  case "getfilterform": $this->getFilterForm(); break;
	  case "getaddtransform": $this->getAddTransForm(); break;
	  case "getaddtransform2": $this->getAddTransForm2(); break;
    }
  }

/**
 * Обработчик действия: Отдает форму добавления пользователя.
 */

  function getAddUserForm()
  {
    $form = new A_Form("module_users_add.tpl");
    if($structure=getStructureByPlugin("groups"))
	$form->data['groups']=A::$DB->getAssoc("SELECT id,name FROM {$structure} WHERE idsec=".SECTION_ID." ORDER BY sort");
	$form->fieldseditor_addprepare();
	$this->RESULT['html'] = $form->getContent();
  }

/**
 * Обработчик действия: Отдает форму редактирования пользователя.
 */

  function getEditUserForm()
  {
    $form = new A_Form("module_users_edit.tpl");
	$form->data=A::$DB->getRowById($_POST['id'],SECTION);
    if($structure=getStructureByPlugin("groups"))
	$form->data['groups']=A::$DB->getAssoc("SELECT id,name FROM {$structure} WHERE idsec=".SECTION_ID." ORDER BY sort");
	$form->fieldseditor_editprepare();
	$this->RESULT['html'] = $form->getContent();
  }

/**
 * Обработчик действия: Отдает форму фильтров.
 */

  function getFilterForm()
  {
    $data=A_Session::get(SECTION."_filter",array());
    $form = new A_Form("module_users_filter.tpl");
    $form->data['id']=$data['id'];
	$form->data['name']=$data['name'];
	$form->data['balance1']=$data['balance1'];
	$form->data['balance2']=$data['balance2'];
	$form->data['idgroup']=$data['idgroup'];
	$form->data['login']=$data['login'];
	$form->data['email']=$data['email'];
	$form->data['date']=$data['date'];
	if($form->data['date'])
	{ $form->data['from']=$data['date1'];
	  $form->data['to']=$data['date2'];
	}
	$form->data['statuss']=array(0=>"Не выбрано","Y"=>"Активирован","N"=>"Ожидает активации");
	$form->data['status']=$data['status'];
    if($structure=getStructureByPlugin("groups"))
	$form->data['groups']=A::$DB->getAssoc("SELECT id,name FROM {$structure} WHERE idsec=".SECTION_ID." ORDER BY sort");
	$form->fieldseditor_filterprepare($data);
	$frame = new A_Frame("default_form.tpl","Фильтр",$form);
	$this->RESULT['html'] = $frame->getContent();
  }

/**
 * Обработчик действия: Отдает форму добавления денежной операции.
 */

  function getAddTransForm()
  {
    $form = new A_Form("module_users_addtrans.tpl");
	$form->data['idusers']=$_POST['idusers'];
	$form->data['box']=$_POST['box'];
	$form->data['valute']=getOption(SECTION,"valute");
	$this->RESULT['html'] = $form->getContent();
  }
}

A::$REQUEST = new UsersModule_Request;