<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package Modules
 */
/**************************************************************************/

/**
 * Панель управления модуля "Пользователи".
 *
 * <a href="http://wiki.a-cms.ru/modules/users">Руководство</a>.
 */

class UsersModule_Admin extends A_MainFrame
{
/**
 * Конструктор.
 */

  function __construct()
  {
    parent::__construct("module_users.tpl");

	$this->AddJScript("/modules/users/admin/users.js");
  }

/**
 * Маршрутизатор действий.
 */

  function Action($action)
  {
    $res=false;
	switch($action)
    { case "adduser": $res=$this->AddUser(); break;
	  case "edituser": $res=$this->EditUser(); break;
	  case "deluser": $res=$this->DelUser(); break;
	  case "setsort": $res=$this->setSort(); break;
	  case "setrows": $res=$this->setRows(); break;
	  case "setrows2": $res=$this->setRows2(); break;
	  case "setfilter": $res=$this->setFilter(); break;
	  case "unfilter": $res=$this->unFilter(); break;
	  case "setactive": $res=$this->SetActive(); break;
	  case "setunactive": $res=$this->SetUnActive(); break;
	  case "delete": $res=$this->Delete(); break;
	  case "delivery": $res=$this->Delivery(); break;
	  case "addtrans": $res=$this->AddTrans(); break;
	  case "deltrans": $res=$this->DelTrans(); break;
	  case "setperiod": $res=$this->SetPeriod(); break;
	}
    if($res)
	A::goUrl("admin.php?mode=sections&item=".SECTION,array('iduser','tab','page'));
  }

/**
 * Обработчик действия: Способ сортировки.
 */

  function setSort()
  {
    A_Session::set(SECTION."_sort",$_REQUEST['sort']);
	setcookie(SECTION."_sort",$_REQUEST['sort'],time()+31104000);
	return true;
  }

/**
 * Обработчик действия: Количество строк на странице пользователей.
 */

  function setRows()
  {
	A_Session::set(SECTION."_rows",$_REQUEST['rows']);
	setcookie(SECTION."_rows",$_REQUEST['rows'],time()+31104000);
	return true;
  }

/**
 * Обработчик действия: Количество строк на странице денежных операций.
 */

  function setRows2()
  {
	A_Session::set(SECTION."_rows2",$_REQUEST['rows']);
	setcookie(SECTION."_rows2",$_REQUEST['rows'],time()+31104000);
	return true;
  }

/**
 * Обработчик действия: Период денежных операций.
 */

  function SetPeriod()
  {
    A_Session::set(SECTION."_tdate1",(integer)$_REQUEST['from']);
	A_Session::set(SECTION."_tdate2",(integer)$_REQUEST['to']);
	return true;
  }

/**
 * Обработчик действия: Установка фильтра.
 */

  function setFilter()
  {
	$data=array();
    $data['active']=true;
    $data['id']=!empty($_REQUEST['id'])?(integer)$_REQUEST['id']:"";
    $data['name']=!empty($_REQUEST['name'])?A::$DB->real_escape_string($_REQUEST['name']):"";
    $data['balance1']=isset($_REQUEST['balance1'])?(float)$_REQUEST['balance1']:0;
	$data['balance2']=isset($_REQUEST['balance2'])?(float)$_REQUEST['balance2']:0;
	$data['idgroup']=isset($_REQUEST['idgroup'])?(integer)$_REQUEST['idgroup']:0;
	$data['login']=!empty($_REQUEST['login'])?A::$DB->real_escape_string($_REQUEST['login']):"";
	$data['email']=!empty($_REQUEST['email'])?A::$DB->real_escape_string($_REQUEST['email']):"";
	$data['date']=isset($_REQUEST['date']);
	$data['date1']=!empty($_REQUEST['from'])?(integer)$_REQUEST['from']:0;
	$data['date2']=!empty($_REQUEST['to'])?(integer)$_REQUEST['to']:0;
	$data['status']=!empty($_REQUEST['status'])?A::$DB->real_escape_string($_REQUEST['status']):"";
	$this->fieldseditor_setfilter($data);
	A_Session::set(SECTION."_filter",$data);
	return true;
  }

/**
 * Обработчик действия: Сброс фильтра.
 */

  function unFilter()
  {
    $data=array("active"=>false,"id"=>"","name"=>"","idgroup"=>0,"login"=>"","email"=>"","balance1"=>"","balance2"=>"","date"=>false,"status"=>0);
	$date1=A::$DB->getOne("SELECT MIN(date) FROM ".SECTION);
	$data['date1']=$date1>0?$date1:time();
	$data['date2']=time();
	$this->fieldseditor_unfilter($data);
	A_Session::set(SECTION."_filter",$data);
    return true;
  }

/**
 * Обработчик действия: Добавление пользователя.
 */

  function AddUser()
  {
	$_REQUEST['login']=trim($_REQUEST['login']);

	if(empty($_REQUEST['login']))
	return false;

	if(A::$DB->existsRow("SELECT id FROM ".SECTION." WHERE login=?",$_REQUEST['login']))
	{ $this->errors['doublelogin']=true;
	  return false;
	}

	$_REQUEST['date']=time();
	$_REQUEST['active']=isset($_REQUEST['active'])?"Y":"N";
	$password=$_REQUEST['password'];
	$_REQUEST['password']=md5($_REQUEST['password']);

	if(empty($_REQUEST['name']))
	{ $_REQUEST['name']="";
	  if(!empty($_REQUEST["name1"]))
	  $_REQUEST['name'].=$_REQUEST["name1"];
	  if(!empty($_REQUEST["name2"]))
	  $_REQUEST['name'].=" ".$_REQUEST["name2"];
	  if(!empty($_REQUEST["name3"]))
	  $_REQUEST['name'].=" ".$_REQUEST["name3"];
	}

	$_REQUEST['name']=strip_tags(trim($_REQUEST['name']));
	$_REQUEST['login']=strip_tags(trim($_REQUEST['login']));
	$_REQUEST['email']=strip_tags(trim($_REQUEST['email']));

	if(getSectionByModule('forum'))
	{ if(!empty($_REQUEST['name']) && A::$DB->existsRow("SELECT id FROM ".SECTION." WHERE name=?",$_REQUEST['name']))
	  { $this->errors['doublename']=true;
	    return false;
	  }
	}

    $dataset = new A_DataSet(SECTION,true);
    $dataset->fields=array("date","name","login","password","email","active");

	if(isset($_REQUEST['idgroup']))
	$dataset->fields[]="idgroup";

    if($id=$dataset->Insert())
	{
	  if($idimg=UploadImage("image",$_REQUEST['name']))
	  A::$DB->execute("UPDATE ".SECTION." SET idimg=$idimg WHERE id=$id");

	  if(A::$OPTIONS['activatemode']==2)
	  { $_REQUEST['password']=$password;
	    if($mailtpl=A::$OPTIONS['mail_manualactivate'])
	    { $mail = new A_Mail($mailtpl);
	      $mail->Assign("data",$_REQUEST);
          $mail->send("{$_REQUEST['name']}<{$_REQUEST['email']}>");
		}
	  }

	  if(A::$OPTIONS['usebalance'] && A::$OPTIONS['startbalance']>0)
	  A::$OBSERVER->Event('UsersTransaction',SECTION,
	  array('id'=>$id,'in'=>A::$OPTIONS['startbalance'],'out'=>0,'description'=>"Зачисление базовых средств при регистрации."));

	  return true;
	}
	else
	return false;
  }

/**
 * Обработчик действия: Изменение данных пользвателя.
 */

  function EditUser()
  {
	$_REQUEST['login']=trim($_REQUEST['login']);

	if(empty($_REQUEST['login']))
	return false;

	if(A::$DB->existsRow("SELECT id FROM ".SECTION." WHERE login=? AND id<>".(integer)$_REQUEST['id'],$_REQUEST['login']))
	{ $this->errors['doublelogin']=true;
	  return false;
	}

    $_REQUEST['active']=isset($_REQUEST['active'])?"Y":"N";
	if(empty($_REQUEST['name']))
	{ $_REQUEST['name']="";
	  if(!empty($_REQUEST["name1"]))
	  $_REQUEST['name'].=$_REQUEST["name1"];
	  if(!empty($_REQUEST["name2"]))
	  $_REQUEST['name'].=" ".$_REQUEST["name2"];
	  if(!empty($_REQUEST["name3"]))
	  $_REQUEST['name'].=" ".$_REQUEST["name3"];
	}

	$_REQUEST['name']=strip_tags(trim($_REQUEST['name']));
	$_REQUEST['login']=strip_tags(trim($_REQUEST['login']));
	$_REQUEST['email']=strip_tags(trim($_REQUEST['email']));

	if(getSectionByModule('forum'))
	{ if(!empty($_REQUEST['name']) && A::$DB->existsRow("SELECT id FROM ".SECTION." WHERE name=? AND id<>".(integer)$_REQUEST['id'],$_REQUEST['name']))
	  { $this->errors['doublename']=true;
	    return false;
	  }
	}

    $dataset = new A_DataSet(SECTION,true);
    $dataset->fields=array("name","login","email","active");

	if(isset($_REQUEST['idgroup']))
	$dataset->fields[]="idgroup";

	if(!empty($_REQUEST['password']))
	{ $password=$_REQUEST['password'];
	  $_REQUEST['password']=md5($_REQUEST['password']);
	  $dataset->fields[]="password";
	}

    if($row=$dataset->Update())
	{
	  $idimg=UploadImage("image",$_REQUEST['name'],$row['idimg']);
	  if($idimg>0)
	  A::$DB->execute("UPDATE ".SECTION." SET idimg=$idimg WHERE id=".$row['id']);
	  if(isset($_REQUEST['imagedel']))
	  { DelRegImage($row['idimg']);
	    A::$DB->execute("UPDATE ".SECTION." SET idimg=0 WHERE id=".$row['id']);
	  }

	  if($_REQUEST['active']=='Y' && $row['active']=='N' && preg_match("/^\?\[(.+)\]$/i",$row['password'],$matches))
	  { $_REQUEST['password']=!empty($password)?$password:$matches[1];
	    if($mailtpl=A::$OPTIONS['mail_manualactivate'])
	    { $mail = new A_Mail($mailtpl);
	      $mail->Assign("data",$_REQUEST);
          $mail->send("{$_REQUEST['name']}<{$_REQUEST['email']}>");
		}
		A::$DB->Update(SECTION,array('password'=>md5($_REQUEST['password'])),"id=".$row['id']);
	  }

	  return true;
	}
	else
	return false;
  }

/**
 * Обработчик действия: Удаление пользователя.
 *
 * @param integer $id=0 Идентификатор пользователя.
 */

  function DelUser($id=0)
  {
    if($id>0)
	$_REQUEST['id']=$id;

    $dataset = new A_DataSet(SECTION,true);
    if($row=$dataset->Delete())
	{ DelRegImage($row['idimg']);
	  A::$DB->execute("DELETE FROM ".SECTION."_transactions WHERE iduser=".$row['id']);
	  return true;
	}
	else
	return false;
  }

/**
 * Обработчик действия: Активация выбранных пользователей.
 */

  function SetActive()
  {
    if(isset($_REQUEST['checkuser']))
	foreach($_REQUEST['checkuser'] as $id)
	if($row=A::$DB->getRowById($id,SECTION))
	{ if($row['active']=='N' && preg_match("/^\?\[(.+)\]$/i",$row['password'],$matches))
	  { $row['password']=$matches[1];
	    if($mailtpl=A::$OPTIONS['mail_manualactivate'])
	    { $mail = new A_Mail($mailtpl);
	      $mail->Assign("data",$row);
          $mail->send("{$row['name']}<{$row['email']}>");
		}
		A::$DB->Update(SECTION,array('password'=>md5($row['password'])),"id=".(integer)$id);
	  }
	  A::$DB->execute("UPDATE ".SECTION." SET active='Y' WHERE id=".(integer)$id);
	}
	return true;
  }

/**
 * Обработчик действия: Отключение выбранных пользователей.
 */

  function SetUnActive()
  {
    if(isset($_REQUEST['checkuser']))
	foreach($_REQUEST['checkuser'] as $id)
	A::$DB->execute("UPDATE ".SECTION." SET active='N' WHERE id=".(integer)$id);
	return true;
  }

/**
 * Обработчик действия: Удаление выбранных пользователей.
 */

  function Delete()
  {
    if(isset($_REQUEST['checkuser']))
	foreach($_REQUEST['checkuser'] as $id)
	$this->DelUser($id);
	return true;
  }

/**
 * Обработчик действия: Добавление денежной операции.
 */

  function AddTrans()
  {
	if(is_numeric($_REQUEST['idusers']))
	A::$OBSERVER->Event('UsersTransaction',SECTION,
	array('id'=>(integer)$_REQUEST['idusers'],'in'=>(float)$_REQUEST['in'],'out'=>(float)$_REQUEST['out'],'description'=>$_REQUEST['description']));
	else
	{ $idusers=explode(",",$_REQUEST['idusers']);
	  foreach($idusers as $id)
	  A::$OBSERVER->Event('UsersTransaction',SECTION,
	  array('id'=>(integer)$id,'in'=>(float)$_REQUEST['in'],'out'=>(float)$_REQUEST['out'],'description'=>$_REQUEST['description']));
	  return true;
	}
  }

/**
 * Обработчик действия: Удаление денежной операции.
 */

  function DelTrans()
  {
    $dataset = new A_DataSet(SECTION."_transactions");
    if($row=$dataset->Delete())
	{ if($row['in']>0)
	  A::$DB->execute("UPDATE ".SECTION." SET balance=balance-{$row['in']} WHERE id=".$row['iduser']);
	  if($row['out']>0)
	  A::$DB->execute("UPDATE ".SECTION." SET balance=balance+{$row['out']} WHERE id=".$row['iduser']);
	  return true;
	}
	else
	return false;
  }

/**
 * Обработчик действия: Рассылка для выбранных пользователей.
 */

  function Delivery()
  {
	$structures=getStructuresByPlugin("delivery");

	foreach($structures as $s)
	if(getOption($s,'subsection')==SECTION_ID)
	{ $structure=$s;
	  break;
	}

	if(empty($structure)) return false;

	$where="";
	if(isset($_REQUEST['checkuser']))
	{ foreach($_REQUEST['checkuser'] as $i=>$id)
	  $_REQUEST['checkuser'][$i]=(integer)$id;
	  $where="id IN(".implode(',',$_REQUEST['checkuser']).")";
	}
	else
	$where=$this->getFilter();

	A_Session::set($structure."_filter",$where);

	A::goUrl("admin.php?mode=structures&item=".$structure);
  }

/**
* Формирование условия SQL запроса по текущим фильтрам.
 *
 * @return string
 */

  function getFilter()
  {
    $data=A_Session::get(SECTION."_filter",array());
	if($data['active'])
	{ $where=array();
	  if(!empty($data['id']))
	  $where[]="id=".$data['id'];
	  if(!empty($data['name']))
	  $where[]="name LIKE '%".$data['name']."%'";
	  if(!empty($data['login']))
	  $where[]="login LIKE '%".$data['login']."%'";
	  if(!empty($data['balance1']))
	  $where[]="balance>=".$data['balance1'];
	  if(!empty($data['balance2']))
	  $where[]="balance<=".$data['balance2'];
	  if(!empty($data['idgroup']))
	  { if($structure=getStructureByPlugin("groups"))
	    { $groups=A::$DB->getAssoc("SELECT id,name FROM {$structure} WHERE idsec=".SECTION_ID." ORDER BY sort");
		  if($data['idgroup']==key($groups))
		  $where[]="(idgroup=0 OR idgroup=".$data['idgroup'].")";
		  else
	      $where[]="idgroup=".$data['idgroup'];
	    }
      }
	  if(!empty($data['email']))
	  $where[]="email LIKE '%".$data['email']."%'";
	  if($data['date'])
	  $where[]="date>=".$data['date1']." AND date<=".$data['date2'];
	  if(!empty($data['status']))
	  $where[]="active='".$data['status']."'";
	  return $this->adminfilter(implode(" AND ",$where),$data);
	}
	return "";
  }

/**
 * Формирование данных доступных в шаблоне.
 */

  function createData()
  {
    if(!A_Session::is_set(SECTION."_filter"))
    $this->unFilter();

	if($structure=getStructureByPlugin("groups"))
	{ $groups=A::$DB->getAssoc("SELECT id,name FROM {$structure} WHERE idsec=".SECTION_ID." ORDER BY sort");
	  $this->Assign("fgroups",!empty($groups));
	}

	$where=$this->getFilter();

	$rows=(integer)A_Session::get(SECTION."_rows",isset($_COOKIE[SECTION.'_rows'])?$_COOKIE[SECTION.'_rows']:20);
	$sort=escape_order_string(A_Session::get(SECTION."_sort",isset($_COOKIE[SECTION.'_sort'])?A::$DB->real_escape_string($_COOKIE[SECTION.'_sort']):"date DESC"));

	$users=array();
	$pager = new A_Pager($rows);
	$pager->tab="users";
    $pager->query("SELECT * FROM ".SECTION.(!empty($where)?" WHERE $where":"")."
	ORDER BY $sort");
    while($row=$pager->fetchRow())
	{ $row['balance']=round($row['balance'],2);
	  if(isset($groups[$row['idgroup']]))
	  $row['groupname']=$groups[$row['idgroup']];
	  elseif($row['idgroup']==0 && !empty($groups))
	  $row['groupname']=current($groups);
      $users[]=$row;
	}

	$this->Assign("users",$users);
	$this->Assign("users_pager",$pager);

	$structure=getStructureByPlugin("delivery");
	if(!empty($structure))
	$this->Assign("usedelivery",getOption($structure,'subsection')==SECTION_ID);

	$this->Assign("optbox1",new A_OptionsBox("Регистрация:",array("idgroup"=>1)));
	$this->Assign("optbox2",new A_OptionsBox("Лого/Аватары:",array("idgroup"=>2)));
	$this->Assign("optbox3",new A_OptionsBox("Денежный баланс:",array("idgroup"=>3)));
	$this->Assign("optbox4",new A_OptionsBox("Шаблоны писем:",array("idgroup"=>4)));

	$this->Assign("fieldsbox",new A_FieldsEditor(SECTION,array('tab'=>'opt','tab_opt'=>'fields'),true,true,true));

	$this->Assign("rows",$rows);
	$this->Assign("sort",$sort);
	$this->Assign("filter",!empty($where));

	if(A::$OPTIONS['usebalance'])
	{
	  if(!empty($_GET['iduser']))
	  { $_GET['iduser']=(integer)$_GET['iduser'];
	    $this->Assign("user",A::$DB->getRowById($_GET['iduser'],SECTION));
	  }

      $month=date("m",time());
	  $year=date("Y",time());
	  $date1=mktime(0,0,0,$month,1,$year);
	  $month++;
	  if($month==13)
	  { $month=1;
	    $year++;
	  }
      $date2=mktime(0,0,0,$month,1,$year);

	  $date1=(integer)A_Session::get(SECTION."_tdate1",$date1);
	  $date2=(integer)A_Session::get(SECTION."_tdate2",$date2);

	  $where="t.date>$date1 AND t.date<$date2";
	  if(!empty($_GET['iduser']))
	  $where.=" AND t.iduser=".(integer)$_GET['iduser'];

	  $rows=(integer)A_Session::get(SECTION."_rows2",isset($_COOKIE[SECTION.'_rows2'])?$_COOKIE[SECTION.'_rows2']:10);

	  $transactions=array();
	  $pager2 = new A_Pager($rows);
	  $pager2->tab="trans";
      $pager2->query("
	  SELECT t.*,u.name AS user FROM ".SECTION."_transactions AS t
	  LEFT JOIN ".SECTION." AS u ON u.id=t.iduser
	  WHERE $where
	  ORDER BY date DESC");
      while($row=$pager2->fetchRow())
	  { $row['in']=round($row['in'],2);
	    $row['out']=round($row['out'],2);
        $transactions[]=$row;
	  }

	  $this->Assign("transactions",$transactions);
	  $this->Assign("transactions_pager",$pager2);

	  $sumin=A::$DB->getOne("SELECT SUM(`in`) FROM ".SECTION."_transactions AS t WHERE $where");
	  $sumout=A::$DB->getOne("SELECT SUM(`out`) FROM ".SECTION."_transactions AS t WHERE $where");

	  $this->Assign("sumin",round($sumin,2));
	  $this->Assign("sumout",round($sumout,2));
	  $this->Assign("sumbalance",round($sumin-$sumout,2));
	  $this->Assign("statfrom",$date1);
	  $this->Assign("statto",$date2);

	  $this->Assign("rows2",$rows);
	}
  }
}

A::$MAINFRAME = new UsersModule_Admin;