<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package Modules
 */
/**************************************************************************/

/**
 * Обработчик события "Денежная операция".
 *
 * @param string $section Полный строковой идентификатор раздела.
 * @param array $params Параметры события.
 */

function users_transaction($section,$params)
{
  $usection=getSectionByModule('users');
  if($usection && ($params['in']>0 || $params['out']>0))
  { $values=array("date"=>time(),"iduser"=>$params['id'],"in"=>$params['in'],"out"=>$params['out'],"description"=>$params['description']);
    if(A::$DB->Insert($usection."_transactions",$values))
	{ if($params['in']>0)
	  A::$DB->execute("UPDATE {$usection} SET balance=balance+{$params['in']} WHERE id={$params['id']}");
	  if($params['out']>0)
	  A::$DB->execute("UPDATE {$usection} SET balance=balance-{$params['out']} WHERE id={$params['id']}");
	  return true;
	}
  }
  return false;
}

A::$OBSERVER->AddHandler('UsersTransaction','users_transaction');

/**
 * Обработчик события на любое действие, реализует авторегистрацию.
 *
 * @param string $section Полный строковой идентификатор раздела.
 * @param array $params Параметры события.
 */

function users_autoreg($section,$params)
{
  if(A_MODE==1 || MODULE=='users' || empty(A::$AUTH->section)) return;
  if(!isset($_REQUEST['autoreg'])) return;
  if(empty($_REQUEST['email']) || !preg_match("/^[a-zA-Z0-9_.-]+@[a-zA-Z0-9_.-]+\.[a-zA-Z0-9]+$/i",$_REQUEST['email'])) return;

  $options=getOptions(A::$AUTH->section);

  $data=array(
  'date'=>time(),
  'name'=>!empty($_REQUEST['name'])?strip_tags($_REQUEST['name']):strip_tags($_REQUEST['email']),
  'login'=>strip_tags($_REQUEST['email']),
  'password'=>mb_substr(md5(time()),0,8),
  'email'=>strip_tags($_REQUEST['email']),
  'active'=>$options['activatemode']==0?'Y':'N',
  );

  if(MODULE=='faq')
  $data['name']=!empty($_REQUEST['user'])?strip_tags($_REQUEST['user']):strip_tags($_REQUEST['email']);

  if(A::$DB->existsRow("SELECT id FROM ".A::$AUTH->section." WHERE login=?",$data['login']))
  return;

  $password=$data['password'];

  switch($options['activatemode'])
  { case 0:
    case 1: $data['password']=md5($data['password']); break;
    case 2: $data['password']='?['.$data['password'].']'; break;
  }

  A::$DB->query("SELECT * FROM ".DOMAIN."_fields WHERE item='".A::$AUTH->section."' AND nofront='N' ORDER BY sort");
  while($row=A::$DB->fetchRow())
  switch($row['type'])
  { case "int":
    case "select":
	  $data[$row['field']]=isset($_REQUEST[$row['field']])?(integer)$_REQUEST[$row['field']]:0;
	  break;
	case "mselect":
	  if(!empty($_REQUEST[$row['field']]) && is_array($_REQUEST[$row['field']]))
	  { $values=array();
		foreach($_REQUEST[$row['field']] as $sid)
		$values[]=sprintf("%04d",(integer)$sid);
		$data[$row['field']]=implode(",",$values);
	  }
	  else
	  $data[$row['field']]="";
	  break;
    case "float":
	  $data[$row['field']]=isset($_REQUEST[$row['field']])?(float)$_REQUEST[$row['field']]:0;
	  break;
    case "bool":
	  $data[$row['field']]=isset($_REQUEST[$row['field']])?"Y":"N";
	  break;
	case "date":
	  $data[$row['field']]=!empty($_REQUEST[$row['field']])?(integer)$_REQUEST[$row['field']]:0;
	  break;
	case "string":
	case "text":
	  $data[$row['field']]=isset($_REQUEST[$row['field']])?strip_tags($_REQUEST[$row['field']]):"";
	  break;
  }
  A::$DB->free();

  if($id=A::$DB->Insert(A::$AUTH->section,$data))
  { A::$AUTH->id=$id;
    $data['password']=$password;

	if(!empty($options['sendmessage']))
	{ if(!empty($options['mail_regnew']))
	  { $mail = new A_Mail($options['mail_regnew']);
	    $mail->Assign("data",$data);
	    $mail->send($options['sendmessage']);
	  }
	}

	switch($options['activatemode'])
	{ case 0:
	    if(!empty($options['mail_register']))
		{ $mail = new A_Mail($options['mail_register']);
	      $mail->Assign("data",$data);
          $mail->send($data['email']);
		}
		break;
	  case 1:
	    if(!empty($options['mail_activate']))
		{ $mail = new A_Mail($options['mail_activate']);
	      $mail->Assign("data",$data);
		  $mail->Assign("activatelink","http://".HOSTNAME.getSectionLink(A::$AUTH->section)."register.html?action=activate&id={$id}&code=".md5(A::$AUTH->section.$data['date']));
          $mail->send($data['email']);
		}
		break;
	}

	if($options['usebalance'] && $options['startbalance']>0)
	A::$OBSERVER->Event('UsersTransaction',A::$AUTH->section,
	array('id'=>$id,'in'=>$options['startbalance'],'out'=>0,'description'=>"Зачисление базовых средств при регистрации."));
  }
}

A::$OBSERVER->AddHandler('Action','users_autoreg');